#!/bin/bash
# 
# Copyright (C) 2009, Intel Corporation.
# 
# This program is free software; you can redistribute it and/or modify it
# under the terms and conditions of the GNU General Public License,
# version 2, as published by the Free Software Foundation.
#
# This program is distributed in the hope it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.  
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place - Suite 330, Boston, MA 02111-1307 USA.
#
# Authors:
#              Wei, Zhang <wei.z.zhang@intel.com>
#

XT_FONTPATH=/opt/moblin/share/fonts/misc/
EXIST_DISPLAY="`ls /tmp/.X11-unix/ | awk -FX '{print $2}' | sort -u`"
SCREEN=0
dc=0
TEST_DISPLAY=

for d in $EXIST_DISPLAY; do
	if [ "$d" == "$dc" ];then
		dc="$(($d+1))"
	else
		TEST_DISPLAY=:${dc}.${SCREEN}
		break
	fi
done

if [ x"$TEST_DISPLAY" == x ]; then
	TEST_DISPLAY=:${dc}.${SCREEN}
fi

echo $TEST_DISPLAY

# startXvfb and stopXvfb are from lsb-desktop <run_tests>
# start xvfb if it isn't already running
startXvfb()
{
    if [ -z "$1" ];then
        render='-render'
    else
        render=''
    fi
    
    running=`pidof Xvfb`
    if [ -z "$running" ];then
        /opt/moblin/bin/Xvfb $render -screen $SCREEN 1024x768x24 $TEST_DISPLAY -ac +bs -kb -fp $XT_FONTPATH &
        echo "Starting X Virtual Frame Buffer"; sleep 20
        export DISPLAY=$TEST_DISPLAY
        export G_SLICE=always-malloc
    fi
}

stopXvfb()
{
    running=`pidof Xvfb`
    if [ -n "$running" ];then
        # kill xvfb
        kill $running
    fi
}

startXvfb

# get test entries list
test_entries="`cat ./test_entries`"

# run and journal
workdir=${PWD}
${workdir}/../../tetj/gtest-to-tet-1.py -j $test_entries

# move journal to result
mv journal.all result

stopXvfb
